%%
clc
clear all
obj = VideoReader('test_naprijed.avi');
nframes = get(obj, 'NumberOfFrames');
f=obj.FrameRate;
%%
sz = get(0,'ScreenSize');
pos = [20 sz(4)-300 200 200];
hVideo1 = vision.VideoPlayer('Name','Original Video','Position',pos);
pos(1) = pos(1)+220; % move the next viewer to the right
hVideo2 = vision.VideoPlayer('Name','Tracking Video','Position',pos);

%%
rectangle = vision.ShapeInserter('BorderColor','Custom','CustomBorderColor',[0 255 0]);
                                
pointTracker = vision.MarkerInserter('Shape','Plus','BorderColor', 'Custom','CustomBorderColor',[0 255 0]);


%%
n=3400;
m=4000;
slika=read(obj,3000)
for i = n:m
    j=i-n+1;
    frame = read(obj,i);
    % Now to track red objects in real time
    % we have to subtract the red component 
    % from the grayscale image to extract the red components in the image.
    diff_im = imsubtract(frame(:,:,1), rgb2gray(frame));
    %Use a median filter to filter out noise
    diff_im = medfilt2(diff_im, [3 3]);
    % Convert the resulting grayscale image into a binary image.
    diff_im = im2bw(diff_im,0.15);
    
    % Remove all those pixels less than 50px
     diff_im = bwareaopen(diff_im,200);
    
    % Label all the connected components in the image.
    bw = bwlabel(diff_im, 8);
    
    % Here we do the image blob analysis.
    % We get a set of properties for each labeled region.
    stats = regionprops(bw, 'BoundingBox', 'Centroid');
    
    if(isempty(stats))
        tracking = step(pointTracker,frame,uint16([0 0]));
     
    else
    %This is a loop to bound the red objects in a rectangular box.
       for object = 1:length(stats)
        bb = uint16(stats(object).BoundingBox);
        tracking = step(rectangle, frame, bb);
        bc = uint16(stats(object).Centroid);
        x(j,1) = double(bc(1));
        y(j,1) = double(bc(2));
        tracking = step(pointTracker, tracking, bc);
       end
       if(j>=2)
        dist(j-1,1) = sqrt((x(j,1)-x(j-1,1))^2+(y(j,1)-y(j-1,1))^2);
        vel(j-1,1)=dist(j-1,1)*f;
       end
    end
    step(hVideo1, frame);
    step(hVideo2,tracking);
   
end
Both the loops end here.



